typedef GLfloat Vec3[3];
#define MAX_VERTS 70000
#define MAX_TRIANGLES 140000
#define FOV 45.0
#define ZFAR 2000.0
enum {VENUS_MODEL=0, CUBE_MODEL, BUNNY_MODEL,FACE_MODEL};
#define NUM_OBJECTS (FACE_MODEL+1)
enum {DEMO, OBJ_WIRED, OBJ_FRONT, SIL_FAT, SHARP, VALLEY, SILRIDGE, SILRIDGEVALLEY, INTERSECT,
	OBJ_BACK,  OBJ_WIREFILLED,
	   VALLEYINTERSECT,
	  SIL_AND_OBJ, CHARCOAL,SIL_LINE, SIL_ZSCALED,
	  FACE_MODE, VENUS_MODE, CUBE_MODE, BUNNY_MODE};

struct {
	int numVerts;
	struct  {
		GLfloat d[3];
		int numEdges;
		struct  {
			int vertNum;
			double dihydral;
			GLfloat normal[2][3];
		} edges[10];
	}verts[MAX_VERTS];
} vertStruct[NUM_OBJECTS];

struct {
	int numTris;
	struct  {
		int vert[3];
		GLfloat color[3];
		GLfloat norm[3];
		GLfloat midpt[3];
	} tris[MAX_TRIANGLES];
} trisStruct[NUM_OBJECTS];

void readModel(char *flname, int num)
{
	int i,numTriangles;
	int pt1, pt2, pt3;
	GLfloat cl1, cl2, cl3;
	FILE *fp;
	char buf[100];
	GLfloat normal[3];
	GLfloat temp1[3], temp2[3];
	GLfloat magnFactor = 36.0;
	
	if ((fp = fopen(flname,"r")) == NULL) {
		printf("failed to open input file %s\n", flname);
		exit(-1);
	}
	
	fgets(buf,100,fp);
	sscanf(buf,"%d", &vertStruct[num].numVerts);
	printf("%s \t: Vertices : %d \t| ", flname, vertStruct[num].numVerts);
	for (i= 0 ; i < vertStruct[num].numVerts; i++) {
		fgets(buf,100,fp);
		sscanf(buf,"%f %f %f",&vertStruct[num].verts[i].d[0], &vertStruct[num].verts[i].d[1], &vertStruct[num].verts[i].d[2]);
		if (num == VENUS_MODEL) {
			magnFactor = 36.0;
			vertStruct[num].verts[i].d[0] *= magnFactor;
			vertStruct[num].verts[i].d[1] *= magnFactor;
			vertStruct[num].verts[i].d[2] *= magnFactor;
		}
		if ((num == CUBE_MODEL) || (num == BUNNY_MODEL)){
			magnFactor = 300.0;
			vertStruct[num].verts[i].d[0] *= magnFactor;
			vertStruct[num].verts[i].d[1] *= magnFactor;
			vertStruct[num].verts[i].d[2] *= magnFactor;
		}
	}
	
	fscanf(fp, "%d", &numTriangles);
	printf("Triangles : %d \n", numTriangles);
	trisStruct[num].numTris = numTriangles;
	for (i= 0 ; i < numTriangles; i++) {
		fscanf(fp,"%d %d %d",&pt1, &pt2, &pt3);
		trisStruct[num].tris[i].vert[0] = pt1;
		trisStruct[num].tris[i].vert[1] = pt2;
		trisStruct[num].tris[i].vert[2] = pt3;
		// Read colors
		if (num == BUNNY_MODEL) {
			fscanf(fp,"%f %f %f",&cl1, &cl2, &cl3);
			trisStruct[num].tris[i].color[0] = cl1;
			trisStruct[num].tris[i].color[1] = cl2;
			trisStruct[num].tris[i].color[2] = cl3;
		}
		
		// Assign normal and midpt
		vecSub(vertStruct[num].verts[pt2].d , vertStruct[num].verts[pt1].d, temp1) ;
		vecSub(vertStruct[num].verts[pt3].d ,vertStruct[num].verts[pt2].d, temp2);
		vecCross(temp1, temp2, normal);
		vecNormalize(normal);
		vecAssign(normal, trisStruct[num].tris[i].norm);
		vecAdd(vertStruct[num].verts[pt1].d ,vertStruct[num].verts[pt2].d, temp1);
		vecAdd(vertStruct[num].verts[pt3].d ,temp1, temp2);
		vecScale(temp2, 1.0/3.0,trisStruct[num].tris[i].midpt);
		
	}
	fclose(fp);
	
}

void cleanGLstate()
{
    glDepthFunc(GL_LESS);
    glCullFace(GL_BACK);
    glPolygonMode(GL_FRONT, GL_FILL);
    glDepthMask(GL_TRUE);
}
